      SUBROUTINE HZH2AIDA(dirName,histId,iFlag)

      IMPLICIT NONE

      CHARACTER*16 dirName
      INTEGER histId,iFlag

      REAL HSTATI

      INTEGER IUNIT
      PARAMETER (IUNIT=13)

c     File stem for output files
      CHARACTER*80 stem

c     Function to find number of occupied characters in a string (KERNLIB)
      INTEGER lenocc

      CHARACTER*14 buff,buff1,buff2,buff3,buff4,buff5
      INTEGER buflen
      PARAMETER (buflen=14)

      CHARACTER*80 histTitle
      INTEGER nX,nY,nwt,loc
      REAL xMI,xMA,yMI,yMA

      INTEGER i

      REAL lowBinEdge

      INTEGER noEntries

      REAL mean,rms

      INTEGER maxBins
      PARAMETER (maxBins=1000)

      REAL binContents(1000),binErrors(1000)

      IF (iFlag.eq.1) THEN

c     File stem is first command-line argument
         CALL GETARG(1,stem)
c     Open file for XML output
c         OPEN(unit=iunit,file=stem(1:LENOCC(stem))//'.aida',
c     & status='new')
         OPEN(unit=iunit,file=stem(1:LENOCC(stem))//'.aidml',
     &        status='new')

c     Write out initial info for the aida format.
         WRITE(iunit,1000)
 1000    FORMAT('<?xml version="1.0" encoding="UTF-8"?>')
         WRITE(iunit,1001)
 1001    FORMAT('<!DOCTYPE aida SYSTEM "http://aida.freehep.org/schemas/
     &3.0/aida.dtd">')
         WRITE(iunit,1002)
 1002    FORMAT('<aida version="3.0">')
         WRITE(iunit,1003)
 1003    FORMAT('  <implementation version="1.0" package="FreeHEP"/>')

      ELSEIF (iFlag.eq.2) THEN
         
         CALL HGIVE(histID,histTitle,nX,xMI,xMA,nY,yMI,yMA,nwt,loc)

         WRITE (buff,'(I14)') histId
         CALL CLEFT(buff,1,buflen)

c     Set the histogram name.
         WRITE(iunit,1004) '  <histogram1d name="',
     & 'h',
     & buff(1:lenocc(buff)),
c     & '" title="',
c     & histTitle(1:LENOCC(histTitle)),
     & '" path="/',
     & dirName(1:LENOCC(dirName)),'">'

 1004    FORMAT(A,A,A,A,A,A,A,A)

         WRITE (buff,'(F14.2)') xMA
         CALL CLEFT(buff,1,buflen)

         WRITE (buff1,'(I14)') nX
         CALL CLEFT(buff1,1,buflen)

         WRITE (buff2,'(F14.2)') xMI
         CALL CLEFT(buff2,1,buflen)

         WRITE(iunit,*) '    <axis max="',buff(1:LENOCC(buff)),
     & '" numberOfBins="',buff1(1:LENOCC(buff1)),
     & '" min="',buff2(1:LENOCC(buff2)),'" direction="x">'

         DO i=2,nX

            CALL HIX(histId,i,lowBinEdge)

            WRITE (buff,'(F14.2)') lowBinEdge
            CALL CLEFT(buff,1,buflen)            

            WRITE(iunit,*) '      <binBorder value="',
     & buff(1:LENOCC(buff))
     & ,'" />'

         ENDDO

         WRITE(iunit,*)'    </axis>'

         CALL HNOENT (histId,noEntries)

         WRITE (buff,'(I14)') nX
         CALL CLEFT(buff,1,buflen)
         
         WRITE(iunit,*) '    <statistics entries="',buff(1:LENOCC(buff))
     & ,'">'

         mean = HSTATI(histID,1)
         rms = HSTATI(histID,2)

         WRITE (buff,'(F14.2)') mean
         CALL CLEFT(buff,1,buflen)

         WRITE (buff1,'(F14.2)') rms
         CALL CLEFT(buff1,1,buflen)

         WRITE(iunit,*) '      <statistic direction="x" mean="',
     & buff(1:LENOCC(buff)),'" rms="',
     & buff1(1:LENOCC(buff1)),'" />'

         WRITE(iunit,*) '    </statistics>'

         CALL HUNPAK(histId,binContents)
         CALL HUNPKE(histId,binErrors)

         WRITE(iunit,*)'    <data1d>'

         DO i=1,nX

            WRITE (buff,'(I14)') i
            CALL CLEFT(buff,1,buflen)

            WRITE (buff1,'(F14.2)') binContents(i)
            CALL CLEFT(buff1,1,buflen)

            WRITE (buff3,'(F14.2)') binErrors(i)
            CALL CLEFT(buff3,1,buflen)

            WRITE(iunit,1006)'      <bin1d binNum="',
     & buff(1:LENOCC(buff)),
     & '" height="',buff1(1:LENOCC(buff1)),
     & '" error="',buff3(1:LENOCC(buff3)),
     & '" entries="1" weightedMean="0.00" rms="0.00" />'

 1006       FORMAT(A,A,A,A,A,A,A)

         ENDDO

         WRITE(iunit,*)'    </data1d>'
         WRITE(iunit,*)'  </histogram1d>'

      ELSEIF (iFlag.eq.3) THEN

         WRITE(iunit,*)'</aida>'
         CLOSE(iunit)

      ENDIF

      RETURN
      END
