      SUBROUTINE HZPYTCARDS
c     ------------------
c     Read control cards into the hzcontrol common block.
c     Doesn't actually read cards, but sets up keys for FFREAD.
c
c     Cards specific to Pythia.
c
c     -------------------------
      IMPLICIT NONE

c  Variable and common blocks for steering parameters
#include "hzpytcontrol.inc"

      INTEGER itmp

c  Switch off all subprocesses by default in MSUB
      DO 19 itmp = 1, 500
         hzmsub(itmp) = 0
 19   CONTINUE

c  Initialize steering arrays to (hopefully) unlikely value so we can see
c  later which ones have been overridden in the steering cards.
      DO 20 itmp = 1, 200
         hzmstp(itmp)=-9999
         hzparp(itmp)=-9999.9
         hzmstj(itmp)=-9999
         hzparj(itmp)=-9999.9
         hzckin(itmp)=-9999.9
 20   CONTINUE
      DO 21 itmp = 1, 4285
        hzmdme1(itmp)=-9999
 21   CONTINUE

      DO itmp = 1, hzmaxmstp14
         hzmstp14(itmp)=-999
      ENDDO

      do itmp=1, 81
         hzkfn2(itmp) = -9999
      enddo

C     Initializing SUSY variables
      hzslha1 = 'xxx'
      hzslha2 = 'xxx'

c     Subprocess types
      CALL FFKEY('MSEL',HZMSEL,1,'integer')
      CALL FFKEY('MSUB',HZMSUB,500,'integer')
      CALL FFKEY('MDME1',HZMDME1,4285,'integer')
      CALL FFKEY('HZMSTP14',HZMSTP14,HZMAXMSTP14,'integer')

      CALL FFKEY('MSTP',HZMSTP,200,'integer')
      CALL FFKEY('PARP',HZPARP,200,'real')
      CALL FFKEY('MSTJ',HZMSTJ,200,'integer')
      CALL FFKEY('PARJ',HZPARJ,200,'real')

      CALL FFKEY('CKIN',HZCKIN,200,'real')
      
      call ffkey('KFIN2', HZKFN2, 81, 'integer');

C     Read SUSY settings
      CALL FFKEY('SLHA1',HZSLHA1,32,'text')
      CALL FFKEY('SLHA2',HZSLHA2,32,'text')

      RETURN
      END
